=== added directory 'event_certificate'
=== added file 'event_certificate/__init__.py'
--- event_certificate/__init__.py	1970-01-01 00:00:00 +0000
+++ event_certificate/__init__.py	2009-06-16 14:04:56 +0000
@@ -0,0 +1,25 @@
+# -*- encoding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution	
+#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
+#    $Id$
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+import event_certificate
+import report
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
+

=== added file 'event_certificate/__terp__.py'
--- event_certificate/__terp__.py	1970-01-01 00:00:00 +0000
+++ event_certificate/__terp__.py	2009-06-16 14:04:56 +0000
@@ -0,0 +1,51 @@
+# -*- encoding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution	
+#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
+#    $Id$
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+
+{
+    'name': 'Event Certificate',
+    'version': '0.1',
+    'category': 'Generic Modules/Association',
+    'description': """Organization and management of events Certificate.
+
+    This module allow you
+        * to print certificate related to your events and their registrations
+
+    Note that:
+    - You can define new types of events in
+                Events / Configuration / Types of Events
+    - You can access predefined reports about number of registration per event or per event category in :
+                Events / Reporting
+""",
+    'author': 'Tiny',
+    'depends': ['event'],
+    'init_xml': [],
+    'update_xml': [
+        'event_certificate_view.xml',
+        'event_certificate_report.xml',
+    ],
+    'demo_xml': [],
+    'installable': True,
+    'active': False,
+    'certificate': '',
+}
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'event_certificate/event_certificate.py'
--- event_certificate/event_certificate.py	1970-01-01 00:00:00 +0000
+++ event_certificate/event_certificate.py	2009-06-16 14:04:56 +0000
@@ -0,0 +1,32 @@
+# -*- encoding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution    
+#    Copyright (C) 2004-2008 Tiny SPRL (<http://tiny.be>). All Rights Reserved
+#    $Id$
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import osv, fields
+
+class event(osv.osv):
+    _name = 'event.event'
+    _inherit = 'event.event'
+    _columns = {
+        'trainer_id': fields.many2one('res.partner', 'Trainer'),
+    }
+
+event()

=== added file 'event_certificate/event_certificate_report.xml'
--- event_certificate/event_certificate_report.xml	1970-01-01 00:00:00 +0000
+++ event_certificate/event_certificate_report.xml	2009-06-16 14:04:56 +0000
@@ -0,0 +1,14 @@
+<?xml version="1.0" encoding="utf-8"?>
+<openerp>
+    <data>
+
+        <report auto="False" 
+        id="report_event_certificate" 
+        model="event.registration" 
+        name="event.certificate" 
+        rml="event_certificate/report/event_certificate.rml"
+        string="Certificate"/>
+
+    </data>
+</openerp>
+        
\ No newline at end of file

=== added file 'event_certificate/event_certificate_view.xml'
--- event_certificate/event_certificate_view.xml	1970-01-01 00:00:00 +0000
+++ event_certificate/event_certificate_view.xml	2009-06-16 14:04:56 +0000
@@ -0,0 +1,19 @@
+<?xml version="1.0" encoding="utf-8"?>
+<openerp>
+    <data>
+
+	<record model="ir.ui.view" id="view_event_form_inherit">
+		<field name="name">events.inherit</field>
+		<field name="model">event.event</field>
+		<field name="inherit_id" ref="event.view_event_form"/>
+		<field name="type">form</field>
+		<field name="arch" type="xml">
+			<field name="product_id" position="after">
+				<newline/>
+				<field name="trainer_id"/>
+			</field>
+		</field>
+	</record>
+	
+	</data>
+</openerp>
\ No newline at end of file

=== added directory 'event_certificate/report'
=== added file 'event_certificate/report/__init__.py'
--- event_certificate/report/__init__.py	1970-01-01 00:00:00 +0000
+++ event_certificate/report/__init__.py	2009-06-16 14:04:56 +0000
@@ -0,0 +1,1 @@
+import report_certificate

=== added file 'event_certificate/report/event_certificate.rml'
--- event_certificate/report/event_certificate.rml	1970-01-01 00:00:00 +0000
+++ event_certificate/report/event_certificate.rml	2009-06-16 14:04:56 +0000
@@ -0,0 +1,176 @@
+<?xml version="1.0"?>
+<document filename="test.pdf">
+  <template pageSize="(842.0,595.0)" title="Test" author="Martin Simon" allowSplitting="20">
+    <pageTemplate id="first">
+      <frame id="first" x1="42.0" y1="42.0" width="758" height="511"/>
+			<pageGraphics>
+				<setFont name="Helvetica-Bold" size="9"/>
+				<!--COL 1-->
+				<drawString x="1.50cm" y="20.20cm">[[ company.name ]]</drawString>
+				<image x="28.0cm" y="20.20cm" width="25" height="25" >[[company.logo]] </image>
+				<!--COL 2-->
+				<setFont name="Helvetica" size="9"/>
+				<drawString x="1.50cm" y="1.00cm"> [[ formatLang(time.strftime("%Y-%m-%d %H:%M:%S", time.localtime()),date_time = True) ]]</drawString>
+				<drawString x="27.0cm" y="1.00cm">Page <pageNumber/></drawString>
+
+			    <lineMode width="0.8"/>
+				<lines>1.00cm 20.0cm 29.0cm 20.0cm</lines>
+				<setFont name="Helvetica" size="8"/>
+			  </pageGraphics>
+    </pageTemplate>
+  </template>
+  <stylesheet>
+    <blockTableStyle id="Standard_Outline">
+      <blockAlignment value="LEFT"/>
+      <blockValign value="TOP"/>
+    </blockTableStyle>
+    <blockTableStyle id="Table_header_certificate">
+      <blockAlignment value="LEFT"/>
+      <blockValign value="TOP"/>
+    </blockTableStyle>
+    <blockTableStyle id="Table_partner_name">
+      <blockAlignment value="LEFT"/>
+      <blockValign value="TOP"/>
+    </blockTableStyle>
+    <blockTableStyle id="Table1">
+      <blockAlignment value="LEFT"/>
+      <blockValign value="TOP"/>
+    </blockTableStyle>
+    <blockTableStyle id="Table_comapny_detail">
+      <blockAlignment value="LEFT"/>
+      <blockValign value="TOP"/>
+    </blockTableStyle>
+    <initialize>
+      <paraStyle name="all" alignment="justify"/>
+    </initialize>
+    <paraStyle name="P1" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT"/>
+    <paraStyle name="Standard" fontName="Times-Roman"/>
+    <paraStyle name="Heading" fontName="Helvetica" fontSize="12.0" leading="15" spaceBefore="12.0" spaceAfter="6.0"/>
+    <paraStyle name="Text body" fontName="Times-Roman" spaceBefore="0.0" spaceAfter="6.0"/>
+    <paraStyle name="List" fontName="Helvetica" spaceBefore="0.0" spaceAfter="6.0"/>
+    <paraStyle name="Caption" fontName="Helvetica-Oblique" fontSize="8.0" leading="10" spaceBefore="6.0" spaceAfter="6.0"/>
+    <paraStyle name="Index" fontName="Helvetica" fontSize="9.0" leading="11"/>
+    <paraStyle name="Footer" fontName="Times-Roman"/>
+    <paraStyle name="Table Contents" fontName="Times-Roman"/>
+    <paraStyle name="Table Heading" fontName="Times-Roman" alignment="CENTER"/>
+    <paraStyle name="Horizontal Line" fontName="Times-Roman" fontSize="6.0" leading="8" spaceBefore="0.0" spaceAfter="14.0"/>
+    <paraStyle name="terp_header" fontName="Helvetica-Bold" fontSize="15.0" leading="19" alignment="LEFT" spaceBefore="12.0" spaceAfter="6.0"/>
+    <paraStyle name="Heading 9" fontName="Helvetica-Bold" fontSize="75%" leading="NaN" spaceBefore="12.0" spaceAfter="6.0"/>
+    <paraStyle name="terp_tblheader_General" fontName="Helvetica-Bold" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="6.0" spaceAfter="6.0"/>
+    <paraStyle name="terp_tblheader_Details" fontName="Helvetica-Bold" fontSize="12.0" leading="15" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_default_8" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_default_Bold_8" fontName="Helvetica-Bold" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_tblheader_General_Centre" fontName="Helvetica-Bold" fontSize="8.0" leading="10" alignment="CENTER" spaceBefore="6.0" spaceAfter="6.0"/>
+    <paraStyle name="terp_tblheader_General_Right" fontName="Helvetica-Bold" fontSize="8.0" leading="10" alignment="RIGHT" spaceBefore="6.0" spaceAfter="6.0"/>
+    <paraStyle name="terp_tblheader_Details_Centre" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica-Bold" fontSize="16.0" leading="20" alignment="CENTER" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_tblheader_Details_Right" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica-Bold" fontSize="16.0" leading="20" alignment="RIGHT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_default_Right_8" fontName="Helvetica" fontSize="8.0" leading="10" alignment="RIGHT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_default_Centre_8" fontName="Helvetica" fontSize="8.0" leading="10" alignment="CENTER" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_header_Right" fontName="Helvetica-Bold" fontSize="15.0" leading="19" alignment="LEFT" spaceBefore="12.0" spaceAfter="6.0"/>
+    <paraStyle name="terp_header_Centre" fontName="Helvetica-Bold" fontSize="32.0" leading="39" alignment="CENTER" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_default_address" fontName="Helvetica" fontSize="10.0" leading="13" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_default_9" fontName="Helvetica" fontSize="9.0" leading="11" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_default_Bold_9" fontName="Helvetica-Bold" fontSize="9.0" leading="11" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_default_Centre_9" fontName="Helvetica" fontSize="9.0" leading="11" alignment="CENTER" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_default_Right_9" fontName="Helvetica" fontSize="9.0" leading="11" alignment="RIGHT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_default_space" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="6.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_tblheader_right_6cmbefore" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica-Bold" fontSize="16.0" leading="20" alignment="CENTER" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_tblheader_detail_centre_6cmbefore" rightIndent="198.0" leftIndent="0.0" fontName="Helvetica-Bold" fontSize="16.0" leading="20" alignment="CENTER" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="terp_tblheader_details_Center_new" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica-Bold" fontSize="16.0" leading="20" alignment="CENTER" spaceBefore="0.0" spaceAfter="0.0"/>
+  </stylesheet>
+  <images/>
+  <story>
+    <para style="terp_default_8">
+      <font color="white"> </font>
+    </para>
+    <para style="terp_default_8">
+      <font color="white"> </font>
+    </para>
+    <para style="terp_default_8">
+      <font color="white"> </font>
+    </para>
+    <para style="terp_default_8">[[repeatIn(objects,'event')]]</para>
+    <blockTable colWidths="757.0" style="Table_header_certificate">
+      <tr>
+        <td>
+          <para style="terp_header_Centre">[[ event.event_id.type and event.event_id.type.name ]] Certifications</para>
+        </td>
+      </tr>
+    </blockTable>
+    <para style="terp_default_space">
+      <font color="white"> </font>
+    </para>
+    <para style="terp_default_space">
+      <font color="white"> </font>
+    </para>
+    <blockTable colWidths="757.0" style="Table_partner_name">
+      <tr>
+        <td>
+          <para style="terp_header_Centre">[[ event.partner_id and event.partner_id.name or removeParentNode('para') ]]</para>
+        </td>
+      </tr>
+    </blockTable>
+    <para style="terp_default_space">
+      <font color="white"> </font>
+    </para>
+    <para style="terp_default_space">
+      <font color="white"> </font>
+    </para>
+    <blockTable colWidths="757.0" style="Table1">
+      <tr>
+        <td>
+          <para style="terp_tblheader_details_Center_new">HAS SUCCESSFULLY COMPLETED</para>
+		    <para style="terp_default_space">
+		      <font color="white"> </font>
+		    </para>
+		    <para style="terp_default_space">
+		      <font color="white"> </font>
+		    </para>
+          <para style="terp_header_Centre">[[ event.event_id.name ]] </para>
+        </td>
+      </tr>
+      <tr>
+        <td>
+          <para style="terp_default_space">
+            <font color="white"> </font>
+          </para>
+        </td>
+      </tr>
+      <tr>
+        <td>
+          <para style="terp_tblheader_Details_Centre"> [[ get_date( formatLang(event.event_id.date_begin, date_time=True), formatLang(event.event_id.date_end, date_time=True) ) ]] </para>
+        </td>
+      </tr>
+    </blockTable>
+    <para style="terp_default_space">
+      <font color="white"> </font>
+    </para>
+    <para style="terp_default_space">
+      <font color="white"> </font>
+    </para>
+    <para style="terp_default_space">
+      <font color="white"> </font>
+    </para>
+    <para style="terp_default_space">
+      <font color="white"> </font>
+    </para>
+    <blockTable colWidths="378.0,378.0" style="Table_comapny_detail">
+      <tr>
+        <td>
+          <para style="terp_default_Bold_9">[[ company.partner_id.name ]] </para>
+          <para style="terp_default_Bold_9">[[ company.partner_id.address and company.partner_id.address[0].street or '' ]]</para>
+          <para style="terp_default_Bold_9">[[ company.partner_id.address and company.partner_id.address[0].zip or '' ]] [[ company.partner_id.address and company.partner_id.address[0].city or '' ]] - [[ company.partner_id.address and company.partner_id.address[0].country_id and company.partner_id.address[0].country_id.name or '']]</para>
+          <para style="terp_default_Bold_9">Phone: [[ company.partner_id.address and company.partner_id.address[0].phone or '' ]]</para>
+          <para style="terp_default_Bold_9">Mail: [[ company.partner_id.address and company.partner_id.address[0].email or '' ]]</para>
+        </td>
+        <td>
+          <para style="terp_tblheader_right_6cmbefore">[[ event.event_id.trainer_id.name or '' ]]</para>
+          <para style="terp_tblheader_right_6cmbefore">Trainer </para>
+        </td>
+      </tr>
+    </blockTable>
+    <para style="terp_default_9">
+      <font color="white"> </font>
+    </para>
+  </story>
+</document>

=== added file 'event_certificate/report/event_certificate.sxw'
Binary files event_certificate/report/event_certificate.sxw and event_certificate/report/event_certificate.sxw differ
=== added file 'event_certificate/report/report_certificate.py'
--- event_certificate/report/report_certificate.py	1970-01-01 00:00:00 +0000
+++ event_certificate/report/report_certificate.py	2009-06-16 14:04:56 +0000
@@ -0,0 +1,57 @@
+# -*- encoding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution    
+#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
+#    $Id$
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+import time
+import mx.DateTime
+from report import report_sxw
+from osv import osv
+import pooler
+import rml_parse
+
+class event_certificate(rml_parse.rml_parse):
+    def __init__(self, cr, uid, name, context):
+        super(event_certificate, self).__init__(cr, uid, name, context)
+        self.localcontext.update({
+            'time': time,
+            'get_date':self.get_date,
+        })
+        
+    def get_date(self,st_date,end_date):
+        date_res = ''
+        print "st_date::end_date",str(st_date),str(end_date)
+        try:
+            d1 = mx.DateTime.strptime(str(st_date),'%d/%m/%Y %H:%M:%S')
+            d2 = mx.DateTime.strptime(str(end_date),'%d/%m/%Y %H:%M:%S')
+            print "d1:::d2",d1,d2
+            new_d1 = d1.strftime('%d %B %Y %H:%M:%S')
+            new_d2 = d2.strftime('%d %B %Y %H:%M:%S')
+            print "new_d1:::new_d2",new_d1,new_d2
+            date_res = str(new_d1) +" "+ 'To' +" "+ str(new_d2)
+            print "date_res:::",date_res
+        except Exception,e:
+            print "e:::",e
+            pass
+        return date_res
+            
+    
+report_sxw.report_sxw('report.event.certificate','event.registration','event_certificate/report/event_certificate.rml',parser=event_certificate)
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'event_certificate/report/rml_parse.py'
--- event_certificate/report/rml_parse.py	1970-01-01 00:00:00 +0000
+++ event_certificate/report/rml_parse.py	2009-06-16 14:04:56 +0000
@@ -0,0 +1,170 @@
+# -*- encoding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
+#    $Id$
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+from report import report_sxw
+import xml.dom.minidom
+import os, time
+import osv
+import re
+import tools
+import pooler
+import re
+import sys
+
+
+class rml_parse(report_sxw.rml_parse):
+    def __init__(self, cr, uid, name, context):
+        super(rml_parse, self).__init__(cr, uid, name, context=None)
+        self.localcontext.update({
+            'comma_me': self.comma_me,
+            'format_date': self._get_and_change_date_format_for_swiss,
+            'strip_name' : self._strip_name,
+            'explode_name' : self._explode_name,
+        })
+
+    def comma_me(self,amount):
+        #print "#" + str(amount) + "#"
+        if not amount:
+            amount = 0.0
+        if  type(amount) is float :
+            amount = str('%.2f'%amount)
+        else :
+            amount = str(amount)
+        if (amount == '0'):
+             return ' '
+        orig = amount
+        new = re.sub("^(-?\d+)(\d{3})", "\g<1>'\g<2>", amount)
+        if orig == new:
+            return new
+        else:
+            return self.comma_me(new)
+        
+    def _ellipsis(self, string, maxlen=100, ellipsis = '...'):
+        ellipsis = ellipsis or ''
+        try:
+            return string[:maxlen - len(ellipsis) ] + (ellipsis, '')[len(string) < maxlen]
+        except Exception, e:
+            return False
+        
+    def _strip_name(self, name, maxlen=50):
+        return self._ellipsis(name, maxlen, '...')
+
+    def _get_and_change_date_format_for_swiss (self,date_to_format):
+        date_formatted=''
+        if date_to_format:
+            date_formatted = strptime (date_to_format,'%Y-%m-%d').strftime('%d.%m.%Y')
+        return date_formatted
+
+    def _explode_name(self,chaine,length):
+        # We will test if the size is less then account
+        full_string = ''
+        if (len(str(chaine)) <= length):
+            return chaine
+        #
+        else:
+            chaine = unicode(chaine,'utf8').encode('iso-8859-1')
+            rup = 0
+            for carac in chaine:
+                rup = rup + 1
+                if rup == length:
+                    full_string = full_string + '\n'
+                    full_string = full_string + carac
+                    rup = 0
+                else:
+                    full_string = full_string + carac
+
+        return full_string
+
+    def makeAscii(self,str):
+        try:
+            Stringer = str.encode("utf-8")
+        except UnicodeDecodeError:
+            try:
+                Stringer = str.encode("utf-16")
+            except UnicodeDecodeError:
+                print "UTF_16 Error"
+                Stringer = str
+            else:
+                return Stringer
+        else:
+            return Stringer
+        return Stringer
+    
+    def explode_this(self,chaine,length):
+        #chaine = self.repair_string(chaine)
+        chaine = rstrip(chaine)
+        ast = list(chaine)
+        i = length
+        while i <= len(ast):
+            ast.insert(i,'\n')
+            i = i + length
+        chaine = str("".join(ast))
+        return chaine
+    
+    def repair_string(self,chaine):
+        ast = list(chaine)
+        UnicodeAst = []
+        _previouslyfound = False
+        i = 0
+        #print str(ast)
+        while i < len(ast):
+            elem = ast[i]
+            try:
+                Stringer = elem.encode("utf-8")
+            except UnicodeDecodeError:
+                to_reencode = elem + ast[i+1]
+                print str(to_reencode)
+                Good_char = to_reencode.decode('utf-8')
+                UnicodeAst.append(Good_char)
+                i += i +2
+            else:
+                UnicodeAst.append(elem)
+                i += i + 1
+
+
+        return "".join(UnicodeAst)
+
+    def ReencodeAscii(self,str):
+        print sys.stdin.encoding
+        try:
+            Stringer = str.decode("ascii")
+        except UnicodeEncodeError:
+            print "REENCODING ERROR"
+            return str.encode("ascii")
+        except UnicodeDecodeError:
+            print "DECODING ERROR"
+            return str.encode("ascii")
+
+        else:
+            print Stringer
+            return Stringer
+        
+    def _add_header(self, node, header=1):
+        if header==2:
+            rml_head =  self.rml_header2
+        else:
+            rml_head =  self.rml_header
+        rml_head =  rml_head.replace('<pageGraphics>','''<pageGraphics> <image x="10" y="26cm" height="842.0" width="595.0" >[[company.logo]] </image> ''')
+        return True
+
+
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

